<?php
if(!defined('ABSPATH'))die; // disable direct accessed
//add_action('wp_dashboard_setup', 'WP_sls_dashboard_widget' );

global $wp_version;
if ( $wp_version >= 3.8){
	include_once 'class-wp-list-table-v381.php';
} else { 
	include_once 'class-wp-list-table-v332.php';
}

/*
 * let's call the main admin menu */
add_action('admin_menu','WP_sls_plugin_settings');


/*
 * set the main menu */
function WP_sls_plugin_settings() { 

	add_menu_page(
	'WP Simple Login Security',
	'WP Simple Login Security',
	'administrator',
	'WP_sls',
	'WP_sls_show_login_settings');

	add_submenu_page( 
	'WP_sls', 
	__('Login Settings','WP-simple-login-security'), 
	__('Login Settings','WP-simple-login-security'), 
	'administrator', 
	'WP_sls', 
	'WP_sls_show_login_settings');	


	add_submenu_page( 
	'WP_sls', 
	__('Usage Log','WP-simple-login-security'), 
	__('Usage Log','WP-simple-login-security'), 
	'administrator', 
	'WP_sls_usage', 
	'WP_sls_show_usage_log');			
}



function WP_sls_show_login_settings() { 
	global $WP_sls_options;
	
	$user_can_register = get_option( 'users_can_register' );

	$html = '';
	
	include_once 'wpsls_settings_validation.php';

	/* 
	 * extract the new values
	 */
	$WP_sls_options = get_option('WP_sls_options');
	if (isset($_GET['settingssaved'])){
		$html .= '<div class="updated"><p><strong>'.__('Settings saved','WP-simple-login-security').'</strong></p></div>';
	}
	
	$html .= '<div class="wrap">';
	$html .= '<p>&nbsp;</p>';
	
	$html .= WP_sls_advert();

	$html .= '<h2>'.__('Login Settings','WP-simple-login-security').'</h2>';
	$html .= '<p class="description">Leave fields blank or unchecked if you do not require the function.</p>';

	/*
	* let's display error below the heading
	*/

	if ($WP_sls_error_count){
		$html .= '<div class="error">'.$WP_sls_form_error.'</div>';
	}

	$html .= '<form name="form1" method="post" action="">';
	$html .= '<table class="form-table"><tbody>';	

	/*
	 * CHANGE LOGIN URL
	 */
	$html .= '<tr valign="top">';
	$html .= '<th scope="row"><label for="loginurl">'.__('Your login URL:','WP-simple-login-security').'</label></th>';

	$user_can_register_setting = '';
	if ($WP_sls_options['alt_wplogin_name']==''){
		if ($user_can_register){
			$html .= '<td>'.site_url().'/wp-login.php</p>';
		} else {
			$html .= '<td>'.site_url().'/wp-login.php <p class="description" style="color:#ff0000;font-weight:bold;">'.__('This URL is public. We recommend setting a login key','WP-simple-login-security').'</p>';
		}
	} else {
		if ($user_can_register){
			$html .= '<td>'.site_url().'/wp-login.php?'.$WP_sls_options['alt_wplogin_name'].'</p>';
		} else { 
			$html .= '<td>'.site_url().'/wp-login.php?'.$WP_sls_options['alt_wplogin_name'].' <p class="description" style="color:#006600;font-weight:bold;">'.__('Looking Good! This URL is secured','WP-simple-login-security').'</p>';
		}
	}
	$user_can_register_setting = '';
	if ($user_can_register){
		$user_can_register_setting = '<strong>'.__('Currently your website allows anyone to register','WP-simple-login-security').'</strong>';
	} else { 
		$user_can_register_setting = '<strong>'.__('Currently your website does not allow anyone to register','WP-simple-login-security').'</strong>';
	}
	$html .= '</td>';
	
	$WP_sls_alt_wplogin_name_help_text = '';
	if ($WP_sls_options['alt_wplogin_name']==''){
		if ($user_can_register){
			$WP_sls_alt_wplogin_name_help_text = '<span style="color:#006600">'.__('Your setting is OK. You can leave login key empty.','WP-simple-login-security').'</span><br />'.__('If you allow anyone to register to your website, there\'s no use hiding your login URL since you have to put it somewhere in the frontend (homepage, sidebar, or footer, etc) so that your subscribers can login.  However, you are free to set a login key to any value you want.','WP-simple-login-security');
		} else {
			$WP_sls_alt_wplogin_name_help_text = '<span style="color:#ff0000">'.__('Please provide a login key.','WP-simple-login-security').'</span><br />'.__('If you are the only one or one of the few who access admin area, it is an absolute must that you hide your login URL by providing a login key.','WP-simple-login-security');
		}
	} else { 
		if ($user_can_register){
			$WP_sls_alt_wplogin_name_help_text = '<span style="color:#006600">'.__('Setting a login key when you allow anyone to register is not required but it is still OK to have one.','WP-simple-login-security').'</span><br />'.__('Since you allow anyone to register to your website, you still need to put your login URL somewhere in the frontend (homepage, sidebar, or footer, etc) so that your subscribers can login.','WP-simple-login-security');
		} else {
			$WP_sls_alt_wplogin_name_help_text = '<span style="color:#006600">'.__('Your setting is good! Always keep your login key secret.','WP-simple-login-security').'</span>';
		}
	}

	$html .= '</tr>';
	$html .= '<tr valign="top">';
	$html .= '<th scope="row"><label for="loginkey">'.__('Login key:','WP-simple-login-security').'</label></th>';
	$html .= '<td><input type="text" name="alt_wplogin_name" value="'.$WP_sls_options['alt_wplogin_name'].'" size="30">'.$WP_sls_alt_wplogin_name_error.' <p class="description">'.$WP_sls_alt_wplogin_name_help_text.'<br />'.$user_can_register_setting.'</p>';
	$html .= '<input type="hidden" name="prev_alt_wplogin_name" value="'.$WP_sls_options['alt_wplogin_name'].'"></td>';

	$html .= '</tr>';
	

	/*
	*  REDIRECT URL IN CASE OF INVALID ACCESS
	*/
	if ($WP_sls_options['safe_redirect_location']==''){
		$WP_sls_options['safe_redirect_location'] = 'http://127.0.0.1/';
	}

	$WP_sls_options['safe_redirect_location'] = str_ireplace('http://','',$WP_sls_options['safe_redirect_location']);	
	$WP_sls_options['safe_redirect_location'] = str_ireplace('https://','',$WP_sls_options['safe_redirect_location']);
	
	$html .= '<tr valign="top">';
	$html .= '<th scope="row"><label for="redirecturl">'.__('Redirect here in case of invalid access:','WP-simple-login-security').'</label></th>';
	$html .= '<td>http://<input type="text" name="WP_sls_safe_redirect_location" value="'.$WP_sls_options['safe_redirect_location'].'" size="30" />'.$WP_sls_safe_redirect_location_error.'<p class="description">'.__('We suggest, use http://127.0.0.1/','WP-simple-login-security').'</p></td>';
	$html .= '</tr>';

	

	/*
	 * AUTHENTICATION
	 */
	if ( $WP_sls_options['enable_dual_authentication']=='yes' ) {
		$WP_sls_enable_dual_authentication_check = ' checked="checked" ';
		$WP_sls_enable_dual_authentication_reminder = '<span style="color:#006600;font-weight:bold;">'.__('Looking Good!','WP-simple-login-security').'</span>';
	} else { 
		$WP_sls_enable_dual_authentication_check = '';
		$WP_sls_enable_dual_authentication_reminder = '<span style="color:#ff0000;font-weight:bold;">'.__('Dual authentication is disabled! We recommend enabling it.','WP-simple-login-security').'</span>';
	}

	$html .= '<tr valign="top">';
	$html .= '<th scope="row"><label for="authentication">'.__('Authentication:','WP-simple-login-security').'</label></th>';
	$html .= '<td><input type="checkbox" name="WP_sls_enable_dual_authentication" value="yes" size="30" '.$WP_sls_enable_dual_authentication_check.'/> '.__('Enable dual authentication','WP-simple-login-security').'<p class="description">'.__('A second password will be sent to your email.','WP-simple-login-security').' <strong>'.__('Highly recommended!','WP-simple-login-security').'</strong></p><p class="description">'.$WP_sls_enable_dual_authentication_reminder.'</p></td>';
	$html .= '</tr>';
	
	if ( $WP_sls_options['show_powered_by']=='yes' ) {
		$WP_sls_show_powered_by_check = ' checked="checked" ';
	} else { 
		$WP_sls_show_powered_by_check = '';
	}
	
	$html .= '<tr valign="top">';
	$html .= '<th scope="row"></th>';
	$html .= '<td><input type="checkbox" name="WP_sls_show_powered_by" value="yes" size="30" '.$WP_sls_show_powered_by_check.'/> '.__('Proudly show you are protected by dual authentication','WP-simple-login-security').'<p class="description">'.__('Dual Authentication powered by appears on the login page','WP-simple-login-security').'</p></td>';
	$html .= '</tr>';


	/*
	 * TRACKING
	 */
	if ( $WP_sls_options['disable_remember_me']=='yes' ) {
		$WP_sls_disable_remember_me_check = ' checked="checked" ';
	} else { 
		$WP_sls_disable_remember_me_check = '';
	} 

	$html .= '<tr valign="top">';
	$html .= '<th scope="row"><label for="tracking">'.__('Tracking:','WP-simple-login-security').'</label></th>';
	$html .= '<td><input type="checkbox" name="WP_sls_disable_remember_me" value="yes" size="30" '.$WP_sls_disable_remember_me_check.'/> '.__('Disable "remember me" checkbox','WP-simple-login-security').'<p class="description">'.__('Recommended on public machine','WP-simple-login-security').'</p></td>';
	$html .= '</tr>';

	if ( $WP_sls_options['enable_logging']=='yes' ) {
		$WP_sls_enable_logging_check = ' checked="checked" ';
	} else { 
		$WP_sls_enable_logging_check = '';
	} 

	$html .= '<tr valign="top">';
	$html .= '<th scope="row"></th>';
	$html .= '<td><input type="checkbox" name="WP_sls_enable_logging" value="yes" size="30" '.$WP_sls_enable_logging_check.'/> '.__('Enable logging','WP-simple-login-security').'<p class="description">'.__('Record each access to your site to the database','WP-simple-login-security').'</p></td>';	
	$html .= '</tr>';	 
	
	/*
	 * obscrube login error messages
	 */
	if ( $WP_sls_options['enable_obscure_error_messages']=='yes' ) {
		$WP_sls_enable_obscure_error_messages_check = ' checked="checked" ';
	} else { 
		$WP_sls_enable_obscure_error_messages_check = '';
	} 

	$html .= '<tr valign="top">';
	$html .= '<th scope="row"></th>';
	$html .= '<td><input type="checkbox" name="WP_sls_enable_obscure_error_messages" value="yes" size="30" '.$WP_sls_enable_obscure_error_messages_check.'/> '.__('Enable obscure error messages','WP-simple-login-security').'<p class="description">'.__('Do not give a hint which login field is incorrect.','WP-simple-login-security').'</p></td>';	
	$html .= '</tr>';	 
	
	
	

	/*
	 * submit button
	 */
	$html .= '<tr valign="top">';
	$html .= '<td>'.wp_nonce_field( 'WP_sls_show_login_settings_' ).'<input type="hidden" name="WP_sls_hidden" value="Y"><input type="submit" name="Submit" class="button-primary" value="'.__('Save changes','WP-simple-login-security').'" /></td>';
	$html .= '<td></td>';
	$html .= '</tr>';
	$html .= '</tbody></table>';
	$html .= '</form>';
	$html .= '</div>';

	echo $html;
}



function WP_sls_show_usage_log() { 

	global $wpdb;
	global $WP_sls_options;

	echo '<div class="wrap">';
	echo '<p>&nbsp;</p>';
	
	echo WP_sls_advert();

	echo '<h2>'.__('Usage Log','WP-simple-login-security').'</h2>';

	if ($WP_sls_options['enable_logging']=='yes'){
		$WP_sls_table = new Log_List_Table();
		$WP_sls_table->prepare_items();
		$WP_sls_table->display();
	} else { 
		print '<p>'.__('Logging is disabled.  Please go to settings page to enable logging.','WP-simple-login-security').'</p>';
	}
	echo '</div>';
}




// add_action( 'welcome_panel', 'WP_sls_welcome_panel' );
function WP_sls_advert() {
	$wt_link = 'http://wealthtraders.com/exclusive-wpsls-users';
	return '<div>
		<img style="max-width:512px;width:100%;" src="'.WPSLS_PLUGIN_URL.'/images/WP-smple-login-security.jpg'.'" alt="Wordpress Simple Login Security" />
		<div class="update-nag"><b>Exclusive to WP Simple Login Security users:</b> Three products which can help you in your online and offline operations. <a href="'.esc_url($wt_link).'" target="_blank">Click Here...</a></div>	
	</div>';
}




/*
 * WELCOME PANEL
 */
// Register the new dashboard widget with the 'wp_dashboard_setup' action
function WP_sls_dashboard_widget_content(){ 

	include_once( ABSPATH . WPINC . '/feed.php' );
	
	// Get a SimplePie feed object from the specified feed source.
	$rss = fetch_feed( 'http://wealthtraders.com/blog-and-articles/feed' );

	if ( ! is_wp_error( $rss ) ) : // Checks that the object is created correctly

		// Figure out how many total items there are, but limit it to 5. 
		$maxitems = $rss->get_item_quantity( 5 ); 

		// Build an array of all the items, starting with element 0 (first element).
		$rss_items = $rss->get_items( 0, $maxitems );

	endif;
	?>

	<ul>
		<?php if ( $maxitems == 0 ) : ?>
			<li><?php _e( 'No items', 'WP-simple-login-security' ); ?></li>
		<?php else : ?>
			<?php // Loop through each feed item and display each item as a hyperlink. ?>
			<?php foreach ( $rss_items as $item ) : ?>
				<li>
					<a href="<?php echo esc_url( $item->get_permalink() ); ?>"
						title="<?php printf( __( 'Posted %s', 'my-text-domain' ), $item->get_date('j F Y | g:i a') ); ?>">
						<?php echo esc_html( $item->get_title() ); ?>
					</a>
				</li>
			<?php endforeach; ?>
		<?php endif; ?>
	</ul>
<?php
}
// Function used in the action hook
function WP_sls_dashboard_widget() {
	global $WP_sls_plugin_name;
	wp_add_dashboard_widget('dashboard_widget', 'WP Simple Login Security', 'WP_sls_dashboard_widget_content');
}





?>