<?php
/*
Plugin Name: WP Simple Login Security
Plugin URI: http://wealthtraders.com/wp-simple-login-security/
Description: This plugin-in uses simple login procedures with dual authentication to reduce the risk of malicious and unauthorized access to a WP site.  You can switch between single and dual authentication in the settings page.
Author: WealthTraders
Author URI: http://wealthtraders.com/
Version: 2.3
Text Domain: WP-simple-login-security
License: GPLv2 or later
License URI: http://www.gnu.org/licenses/gpl-2.0.html
*/

/*	Copyright 2013  WealthTraders
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
if(!defined('ABSPATH'))die; // disable direct accessed
include_once 'wpsls_functions.php';


// let's save variables to avoid calling functions over and over
$WP_sls_user_ip = WP_sls_get_ip_address();
$WP_sls_plugin_name = 'WP Simple Login Security';
$WP_sls_dbtable_version = "1.0"; 
$WP_sls_options = get_option('WP_sls_options');

add_action('init', 'WP_sls_init');
register_activation_hook(__FILE__,'WP_sls_activation');
register_deactivation_hook(__FILE__,'WP_sls_deactivation');
add_action('admin_notices', 'WP_sls_admin_notices');
add_action('wp_logout', 'WP_sls_logout');
add_filter('login_redirect', 'WP_sls_login_redirect', 10, 3 );
add_action('login_init','WP_sls_login_init');
add_action('login_head','WP_sls_login_head');
add_action('login_form','WP_sls_security_code_field');
add_action('login_footer','WP_sls_login_footer');
add_filter('logout_url','WP_sls_logout_url', 10, 2 );
add_filter('login_url','WP_sls_login_url', 10, 2 );


/*
 * now let's execute dual factor authentication */
if ($WP_sls_options['enable_dual_authentication']=='yes'){
	add_filter('wp_authenticate_user', 'WP_sls_validate_security_code', 10, 2);
}


/*
 * let's load the admin when user is successfully logged */
if (is_admin()){
	add_action('plugins_loaded', 'WP_sls_can_manage_options');
} 


?>